# forestvpn_api
ForestVPN defeats content restrictions and censorship to deliver unlimited access to video, music, social media, 
and more, from anywhere in the world.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.forestvpn.com/](https://www.forestvpn.com/)

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    path: /path/to/forestvpn_api
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:forestvpn_api/api.dart';

// TODO Configure API key authorization: Bearer
//defaultApiClient.getAuthentication<ApiKeyAuth>('Bearer').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('Bearer').apiKeyPrefix = 'Bearer';

var api_instance = AppleApi();
var notification = AppleStoreServerNotification(); // AppleStoreServerNotification | 

try {
    api_instance.appleStoreServerNotification(notification);
} catch (e) {
    print("Exception when calling AppleApi->appleStoreServerNotification: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.forestvpn.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AppleApi* | [**appleStoreServerNotification**](doc//AppleApi.md#applestoreservernotification) | **POST** /apple/ssn/ | Apple Store Server to Server Notifications
*AppleApi* | [**verifyReceipt**](doc//AppleApi.md#verifyreceipt) | **POST** /apple/verify-receipt/ | Verify receipt
*DnsApi* | [**lookup**](doc//DnsApi.md#lookup) | **POST** /dns/lookup | DNS Lookup
*GeoApi* | [**getCountries**](doc//GeoApi.md#getcountries) | **GET** /countries/ | List of available countries
*GeoApi* | [**getLocations**](doc//GeoApi.md#getlocations) | **GET** /locations/ | List of available locations
*UsageApi* | [**getTraffic**](doc//UsageApi.md#gettraffic) | **GET** /usage/traffic/ | Get traffic usage for current month
*UsageApi* | [**trafficUpdate**](doc//UsageApi.md#trafficupdate) | **POST** /usage/traffic/ | Usage traffic update
*UserApi* | [**getFeatures**](doc//UserApi.md#getfeatures) | **GET** /user/features/ | Get active user features
*UserApi* | [**getPreference**](doc//UserApi.md#getpreference) | **GET** /user/preference/ | Get user preference
*UserApi* | [**getPremium**](doc//UserApi.md#getpremium) | **GET** /user/premium/ | Get premium status details
*UserApi* | [**updatePreference**](doc//UserApi.md#updatepreference) | **PATCH** /user/preference/ | Update user preference
*WireguardApi* | [**createProfile**](doc//WireguardApi.md#createprofile) | **POST** /wg/profiles/ | Create new WireGuard profile
*WireguardApi* | [**deleteProfile**](doc//WireguardApi.md#deleteprofile) | **DELETE** /wg/profiles/{profileId}/ | Delete WireGuarg profile
*WireguardApi* | [**getPeers**](doc//WireguardApi.md#getpeers) | **GET** /wg/peers/ | Retrieve Wireguard peers
*WireguardApi* | [**getProfile**](doc//WireguardApi.md#getprofile) | **GET** /wg/profile/ | Retrieve VPN profile
*WireguardApi* | [**getProfileByID**](doc//WireguardApi.md#getprofilebyid) | **GET** /wg/profiles/{profileId}/ | Retrieve WireGuarg profile
*WireguardApi* | [**getProfiles**](doc//WireguardApi.md#getprofiles) | **GET** /wg/profiles/ | Retrieve list of WireGuard profiles


## Documentation For Models

 - [AppleStoreLatestReceiptInfo](doc//AppleStoreLatestReceiptInfo.md)
 - [AppleStorePendingRenewalInfo](doc//AppleStorePendingRenewalInfo.md)
 - [AppleStoreServerNotification](doc//AppleStoreServerNotification.md)
 - [AppleStoreUnifiedReceipt](doc//AppleStoreUnifiedReceipt.md)
 - [AppleVerifyReceiptRequest](doc//AppleVerifyReceiptRequest.md)
 - [Country](doc//Country.md)
 - [Error](doc//Error.md)
 - [Feature](doc//Feature.md)
 - [GeoPoint](doc//GeoPoint.md)
 - [Location](doc//Location.md)
 - [Lookup](doc//Lookup.md)
 - [LookupRequest](doc//LookupRequest.md)
 - [Preference](doc//Preference.md)
 - [PreferenceUpdateRequest](doc//PreferenceUpdateRequest.md)
 - [Premium](doc//Premium.md)
 - [UsageTraffic](doc//UsageTraffic.md)
 - [UsageTrafficUpdateRequest](doc//UsageTrafficUpdateRequest.md)
 - [WireGuardProfileCreateRequest](doc//WireGuardProfileCreateRequest.md)
 - [WireguardInterface](doc//WireguardInterface.md)
 - [WireguardPeer](doc//WireguardPeer.md)
 - [WireguardProfile](doc//WireguardProfile.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

support@forestvpn.com


