# forestvpn_api.model.AppleStoreLatestReceiptInfo

## Load the model package
```dart
import 'package:forestvpn_api/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**cancellationDate** | [**DateTime**](DateTime.md) | The time Apple customer support canceled a transaction, in a date-time format similar to the ISO 8601. This field is only present for refunded transactions. | [optional] [default to null]
**cancellationReason** | **String** | The reason for a refunded transaction. When a customer cancels a transaction, the App Store gives them a refund and provides a value for this key. A value of “1” indicates that the customer canceled their transaction due to an actual or perceived issue within your app. A value of “0” indicates that the transaction was canceled for another reason; for example, if the customer made the purchase accidentally. | [optional] [default to null]
**expiresDate** | [**DateTime**](DateTime.md) | The time a subscription expires or when it will renew, in a date-time format similar to the ISO 8601. | [optional] [default to null]
**isInIntroOfferPeriod** | **String** | An indicator of whether an auto-renewable subscription is in the introductory price period. See https://developer.apple.com/documentation/appstorereceipts/is_in_intro_offer_period for more information. | [optional] [default to null]
**isTrialPeriod** | **String** | An indicator of whether a subscription is in the free trial period. See https://developer.apple.com/documentation/appstorereceipts/is_trial_period for more information. | [optional] [default to null]
**isUpgraded** | **String** | An indicator that a subscription has been canceled due to an upgrade. This field is only present for upgrade transactions. | [optional] [default to null]
**originalPurchaseDate** | [**DateTime**](DateTime.md) | The time of the original app purchase, in a date-time format similar to ISO 8601. | [optional] [default to null]
**originalTransactionId** | **String** | The transaction identifier of the original purchase. See https://developer.apple.com/documentation/appstorereceipts/original_transaction_id for more information. | [optional] [default to null]
**productId** | **String** | The unique identifier of the product purchased. You provide this value when creating the product in App Store Connect, and it corresponds to the productIdentifier property of the SKPayment object stored in the transaction&#39;s payment property. | [optional] [default to null]
**promotionalOfferId** | **String** | The identifier of the subscription offer redeemed by the user. See https://developer.apple.com/documentation/appstorereceipts/promotional_offer_id for more information. | [optional] [default to null]
**purchaseDate** | [**DateTime**](DateTime.md) | The time the App Store charged the user&#39;s account for a purchased or restored product, or the time the App Store charged the user’s account for a subscription purchase or renewal after a lapse, in a date-time format similar to ISO 8601. | [optional] [default to null]
**quantity** | **String** | The number of consumable products purchased. This value corresponds to the quantity property of the SKPayment object stored in the transaction&#39;s payment property. The value is usually “1” unless modified with a mutable payment. The maximum value is 10. | [optional] [default to null]
**subscriptionGroupIdentifier** | **String** | The identifier of the subscription group to which the subscription belongs. The value for this field is identical to the https://developer.apple.com/documentation/storekit/skproduct/2981047-subscriptiongroupidentifier property in SKProduct. | [optional] [default to null]
**transactionId** | **String** | A unique identifier for a transaction such as a purchase, restore, or renewal. See https://developer.apple.com/documentation/appstorereceipts/transaction_id for more information. | [optional] [default to null]
**webOrderLineItemId** | **String** | A unique identifier for purchase events across devices, including subscription-renewal events. This value is the primary key for identifying subscription purchases. | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


