# forestvpn_api.model.AppleStorePendingRenewalInfo

## Load the model package
```dart
import 'package:forestvpn_api/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**autoRenewProductId** | **String** | The current renewal preference for the auto-renewable subscription. The value for this key corresponds to the productIdentifier property of the product that the customer’s subscription renews. This field is only present if the user downgrades or crossgrades to a subscription of a different duration for the subsequent subscription period. | [optional] [default to null]
**autoRenewStatus** | **String** | The current renewal status for the auto-renewable subscription. See https://developer.apple.com/documentation/appstorereceipts/auto_renew_status for more information. | [optional] [default to null]
**expirationIntent** | **String** | The reason a subscription expired. This field is only present for a receipt that contains an expired auto-renewable subscription. https://developer.apple.com/documentation/appstorereceipts/expiration_intent Possible Values  1: The customer voluntarily canceled their subscription. 2: Billing error; for example, the customer&#39;s payment information was no longer valid. 3: The customer did not agree to a recent price increase. 4: The product was not available for purchase at the time of renewal. 5: Unknown error.  | [optional] [default to null]
**gracePeriodExpiresDate** | [**DateTime**](DateTime.md) | The time at which the grace period for subscription renewals expires, in a date-time format similar to the ISO 8601. | [optional] [default to null]
**isInBillingRetryPeriod** | **String** | A flag that indicates Apple is attempting to renew an expired subscription automatically. This field is only present if an auto-renewable subscription is in the billing retry state. See https://developer.apple.com/documentation/appstorereceipts/is_in_billing_retry_period for more information. | [optional] [default to null]
**originalTransactionId** | **String** | The transaction identifier of the original purchase. | [optional] [default to null]
**priceConsentStatus** | **String** | The price consent status for a subscription price increase. This field is only present if the customer was notified of the price increase. The default value is \&quot;0\&quot; and changes to \&quot;1\&quot; if the customer consents. | [optional] [default to null]
**productId** | **String** | The unique identifier of the product purchased. You provide this value when creating the product in App Store Connect, and it corresponds to the productIdentifier property of the SKPayment object stored in the transaction&#39;s payment property. | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


