# forestvpn_api.model.AppleStoreServerNotification

## Load the model package
```dart
import 'package:forestvpn_api/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**autoRenewAdamId** | **String** | An identifier that App Store Connect generates and the App Store uses to uniquely identify the auto-renewable subscription that the user&#39;s subscription renews. Treat this value as a 64-bit integer. | [optional] [default to null]
**autoRenewProductId** | **String** | The product identifier of the auto-renewable subscription that the user&#39;s subscription renews. | [optional] [default to null]
**autoRenewStatus** | **String** | The current renewal status for an auto-renewable subscription product. Note that these values are different from those of the auto_renew_status in the receipt. | [optional] [default to null]
**autoRenewStatusChangeDate** | [**DateTime**](DateTime.md) | The time at which the renewal status for an auto-renewable subscription was turned on or off, in a date-time format similar to the ISO 8601 standard. | [optional] [default to null]
**environment** | **String** | The environment for which the receipt was generated. | [optional] [default to null]
**expirationIntent** | **int** | The reason a subscription expired. This field is only present for an expired auto-renewable subscription. See expiration_intent for more information. https://developer.apple.com/documentation/appstorereceipts/expiration_intent Possible Values  1: The customer voluntarily canceled their subscription. 2: Billing error; for example, the customer&#39;s payment information was no longer valid. 3: The customer did not agree to a recent price increase. 4: The product was not available for purchase at the time of renewal. 5: Unknown error.  | [optional] [default to null]
**latestExpiredReceipt** | **String** | The latest Base64-encoded transaction receipt. This field appears in the notification instead of latest_receipt for expired transactions. | [optional] [default to null]
**latestExpiredReceiptInfo** | [**List&lt;Object&gt;**](Object.md) |  | [optional] [default to []]
**latestReceipt** | **String** | The latest Base64-encoded transaction receipt. | [default to null]
**latestReceiptInfo** | [**List&lt;AppleStoreLatestReceiptInfo&gt;**](AppleStoreLatestReceiptInfo.md) | The JSON representation of the value in latest_receipt. Note that this field is an array in the receipt but a single object in server-to-server notifications. | [optional] [default to []]
**notificationType** | **String** | The subscription event that triggered the notification. https://developer.apple.com/documentation/appstoreservernotifications/notification_type CANCEL: Indicates that either Apple customer support canceled the subscription or the user upgraded their subscription. The cancellation_date key contains the date and time of the change. DID_CHANGE_RENEWAL_PREF: Indicates the customer made a change in their subscription plan that takes effect at the next renewal. The currently active plan is not affected. DID_CHANGE_RENEWAL_STATUS: Indicates a change in the subscription renewal status. Check auto_renew_status_change_date_ms and auto_renew_status in the JSON response to know the date and time of the last status update and the current renewal status. DID_FAIL_TO_RENEW: Indicates a subscription that failed to renew due to a billing issue. Check is_in_billing_retry_period to know the current retry status of the subscription, and grace_period_expires_date to know the new service expiration date if the subscription is in a billing grace period. DID_RECOVER: Indicates successful automatic renewal of an expired subscription that failed to renew in the past. Check expires_date to determine the next renewal date and time. INITIAL_BUY: Occurs at the initial purchase of the subscription. Store latest_receipt on your server as a token to verify the user’s subscription status at any time, by validating it with the App Store. INTERACTIVE_RENEWAL: Indicates the customer renewed a subscription interactively, either by using your app’s interface, or on the App Store in the account&#39;s Subscriptions settings. Make service available immediately. RENEWAL: Indicates successful automatic renewal of an expired subscription that failed to renew in the past. Check expires_date to determine the next renewal date and time.  | [optional] [default to null]
**password** | **String** | The same value as the shared secret you submit in the password field of the requestBody when validating receipts. | [optional] [default to null]
**unifiedReceipt** | [**AppleStoreUnifiedReceipt**](AppleStoreUnifiedReceipt.md) |  | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


