part of forestvpn_api.api;

class AppleStoreLatestReceiptInfo {
  /* The time Apple customer support canceled a transaction, in a date-time format similar to the ISO 8601. This field is only present for refunded transactions. */
  DateTime cancellationDate = null;
  /* The reason for a refunded transaction. When a customer cancels a transaction, the App Store gives them a refund and provides a value for this key. A value of “1” indicates that the customer canceled their transaction due to an actual or perceived issue within your app. A value of “0” indicates that the transaction was canceled for another reason; for example, if the customer made the purchase accidentally. */
  String cancellationReason = null;
  //enum cancellationReasonEnum {  0,  1,  };{
  /* The time a subscription expires or when it will renew, in a date-time format similar to the ISO 8601. */
  DateTime expiresDate = null;
  /* An indicator of whether an auto-renewable subscription is in the introductory price period. See https://developer.apple.com/documentation/appstorereceipts/is_in_intro_offer_period for more information. */
  String isInIntroOfferPeriod = null;
  //enum isInIntroOfferPeriodEnum {  true,  false,  };{
  /* An indicator of whether a subscription is in the free trial period. See https://developer.apple.com/documentation/appstorereceipts/is_trial_period for more information. */
  String isTrialPeriod = null;
  //enum isTrialPeriodEnum {  true,  false,  };{
  /* An indicator that a subscription has been canceled due to an upgrade. This field is only present for upgrade transactions. */
  String isUpgraded = null;
  //enum isUpgradedEnum {  true,  };{
  /* The time of the original app purchase, in a date-time format similar to ISO 8601. */
  DateTime originalPurchaseDate = null;
  /* The transaction identifier of the original purchase. See https://developer.apple.com/documentation/appstorereceipts/original_transaction_id for more information. */
  String originalTransactionId = null;
  /* The unique identifier of the product purchased. You provide this value when creating the product in App Store Connect, and it corresponds to the productIdentifier property of the SKPayment object stored in the transaction's payment property. */
  String productId = null;
  /* The identifier of the subscription offer redeemed by the user. See https://developer.apple.com/documentation/appstorereceipts/promotional_offer_id for more information. */
  String promotionalOfferId = null;
  /* The time the App Store charged the user's account for a purchased or restored product, or the time the App Store charged the user’s account for a subscription purchase or renewal after a lapse, in a date-time format similar to ISO 8601. */
  DateTime purchaseDate = null;
  /* The number of consumable products purchased. This value corresponds to the quantity property of the SKPayment object stored in the transaction's payment property. The value is usually “1” unless modified with a mutable payment. The maximum value is 10. */
  String quantity = null;
  /* The identifier of the subscription group to which the subscription belongs. The value for this field is identical to the https://developer.apple.com/documentation/storekit/skproduct/2981047-subscriptiongroupidentifier property in SKProduct. */
  String subscriptionGroupIdentifier = null;
  /* A unique identifier for a transaction such as a purchase, restore, or renewal. See https://developer.apple.com/documentation/appstorereceipts/transaction_id for more information. */
  String transactionId = null;
  /* A unique identifier for purchase events across devices, including subscription-renewal events. This value is the primary key for identifying subscription purchases. */
  String webOrderLineItemId = null;
  AppleStoreLatestReceiptInfo();

  @override
  String toString() {
    return 'AppleStoreLatestReceiptInfo[cancellationDate=$cancellationDate, cancellationReason=$cancellationReason, expiresDate=$expiresDate, isInIntroOfferPeriod=$isInIntroOfferPeriod, isTrialPeriod=$isTrialPeriod, isUpgraded=$isUpgraded, originalPurchaseDate=$originalPurchaseDate, originalTransactionId=$originalTransactionId, productId=$productId, promotionalOfferId=$promotionalOfferId, purchaseDate=$purchaseDate, quantity=$quantity, subscriptionGroupIdentifier=$subscriptionGroupIdentifier, transactionId=$transactionId, webOrderLineItemId=$webOrderLineItemId, ]';
  }

  AppleStoreLatestReceiptInfo.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    cancellationDate = (json['cancellation_date'] == null) ?
      null :
      DateTime.parse(json['cancellation_date']);
    cancellationReason = json['cancellation_reason'];
    expiresDate = (json['expires_date'] == null) ?
      null :
      DateTime.parse(json['expires_date']);
    isInIntroOfferPeriod = json['is_in_intro_offer_period'];
    isTrialPeriod = json['is_trial_period'];
    isUpgraded = json['is_upgraded'];
    originalPurchaseDate = (json['original_purchase_date'] == null) ?
      null :
      DateTime.parse(json['original_purchase_date']);
    originalTransactionId = json['original_transaction_id'];
    productId = json['product_id'];
    promotionalOfferId = json['promotional_offer_id'];
    purchaseDate = (json['purchase_date'] == null) ?
      null :
      DateTime.parse(json['purchase_date']);
    quantity = json['quantity'];
    subscriptionGroupIdentifier = json['subscription_group_identifier'];
    transactionId = json['transaction_id'];
    webOrderLineItemId = json['web_order_line_item_id'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (cancellationDate != null)
      json['cancellation_date'] = cancellationDate == null ? null : cancellationDate.toUtc().toIso8601String();
    if (cancellationReason != null)
      json['cancellation_reason'] = cancellationReason;
    if (expiresDate != null)
      json['expires_date'] = expiresDate == null ? null : expiresDate.toUtc().toIso8601String();
    if (isInIntroOfferPeriod != null)
      json['is_in_intro_offer_period'] = isInIntroOfferPeriod;
    if (isTrialPeriod != null)
      json['is_trial_period'] = isTrialPeriod;
    if (isUpgraded != null)
      json['is_upgraded'] = isUpgraded;
    if (originalPurchaseDate != null)
      json['original_purchase_date'] = originalPurchaseDate == null ? null : originalPurchaseDate.toUtc().toIso8601String();
    if (originalTransactionId != null)
      json['original_transaction_id'] = originalTransactionId;
    if (productId != null)
      json['product_id'] = productId;
    if (promotionalOfferId != null)
      json['promotional_offer_id'] = promotionalOfferId;
    if (purchaseDate != null)
      json['purchase_date'] = purchaseDate == null ? null : purchaseDate.toUtc().toIso8601String();
    if (quantity != null)
      json['quantity'] = quantity;
    if (subscriptionGroupIdentifier != null)
      json['subscription_group_identifier'] = subscriptionGroupIdentifier;
    if (transactionId != null)
      json['transaction_id'] = transactionId;
    if (webOrderLineItemId != null)
      json['web_order_line_item_id'] = webOrderLineItemId;
    return json;
  }

  static List<AppleStoreLatestReceiptInfo> listFromJson(List<dynamic> json) {
    return json == null ? List<AppleStoreLatestReceiptInfo>() : json.map((value) => AppleStoreLatestReceiptInfo.fromJson(value)).toList();
  }

  static Map<String, AppleStoreLatestReceiptInfo> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, AppleStoreLatestReceiptInfo>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = AppleStoreLatestReceiptInfo.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of AppleStoreLatestReceiptInfo-objects as value to a dart map
  static Map<String, List<AppleStoreLatestReceiptInfo>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<AppleStoreLatestReceiptInfo>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = AppleStoreLatestReceiptInfo.listFromJson(value);
       });
     }
     return map;
  }
}

