part of forestvpn_api.api;

class AppleStoreUnifiedReceipt {
  /* The environment for which the receipt was generated. */
  String environment = null;
  //enum environmentEnum {  Sandbox,  Production,  };{
  /* The latest Base64-encoded app receipt. */
  String latestReceipt = null;
  /* The JSON representation of the value in latest_receipt. Note that this field is an array in the receipt but a single object in server-to-server notifications. */
  List<AppleStoreLatestReceiptInfo> latestReceiptInfo = [];
  /* An array where each element contains the pending renewal information for each auto-renewable subscription identified in product_id. The contents of this array are identical to those in responseBody.Pending_renewal_info in the verifyReciept endpoint response for receipt validation. */
  List<AppleStorePendingRenewalInfo> pendingRenewalInfo = [];
  /* The status code, where 0 indicates that the notification is valid. */
  int status = null;
  AppleStoreUnifiedReceipt();

  @override
  String toString() {
    return 'AppleStoreUnifiedReceipt[environment=$environment, latestReceipt=$latestReceipt, latestReceiptInfo=$latestReceiptInfo, pendingRenewalInfo=$pendingRenewalInfo, status=$status, ]';
  }

  AppleStoreUnifiedReceipt.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    environment = json['environment'];
    latestReceipt = json['latest_receipt'];
    latestReceiptInfo = (json['latest_receipt_info'] == null) ?
      null :
      AppleStoreLatestReceiptInfo.listFromJson(json['latest_receipt_info']);
    pendingRenewalInfo = (json['pending_renewal_info'] == null) ?
      null :
      AppleStorePendingRenewalInfo.listFromJson(json['pending_renewal_info']);
    status = json['status'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (environment != null)
      json['environment'] = environment;
    if (latestReceipt != null)
      json['latest_receipt'] = latestReceipt;
    if (latestReceiptInfo != null)
      json['latest_receipt_info'] = latestReceiptInfo;
    if (pendingRenewalInfo != null)
      json['pending_renewal_info'] = pendingRenewalInfo;
    if (status != null)
      json['status'] = status;
    return json;
  }

  static List<AppleStoreUnifiedReceipt> listFromJson(List<dynamic> json) {
    return json == null ? List<AppleStoreUnifiedReceipt>() : json.map((value) => AppleStoreUnifiedReceipt.fromJson(value)).toList();
  }

  static Map<String, AppleStoreUnifiedReceipt> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, AppleStoreUnifiedReceipt>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = AppleStoreUnifiedReceipt.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of AppleStoreUnifiedReceipt-objects as value to a dart map
  static Map<String, List<AppleStoreUnifiedReceipt>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<AppleStoreUnifiedReceipt>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = AppleStoreUnifiedReceipt.listFromJson(value);
       });
     }
     return map;
  }
}

