part of forestvpn_api.api;

class Feature {
  
  String version = null;
  
  String kind = null;
  
  Object spec = null;
  Feature();

  @override
  String toString() {
    return 'Feature[version=$version, kind=$kind, spec=$spec, ]';
  }

  Feature.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    version = json['version'];
    kind = json['kind'];
    spec = json['spec'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (version != null)
      json['version'] = version;
    if (kind != null)
      json['kind'] = kind;
    if (spec != null)
      json['spec'] = spec;
    return json;
  }

  static List<Feature> listFromJson(List<dynamic> json) {
    return json == null ? List<Feature>() : json.map((value) => Feature.fromJson(value)).toList();
  }

  static Map<String, Feature> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, Feature>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = Feature.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of Feature-objects as value to a dart map
  static Map<String, List<Feature>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<Feature>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = Feature.listFromJson(value);
       });
     }
     return map;
  }
}

