part of forestvpn_api.api;

class WireguardPeer {
  
  String endpoint = null;
  
  String privateKey = null;
  
  String publicKey = null;
  
  String presharedKey = null;
  
  int persistentKeepalive = null;
  
  List<String> allowedIps = [];
  
  DateTime blockedAt = null;
  WireguardPeer();

  @override
  String toString() {
    return 'WireguardPeer[endpoint=$endpoint, privateKey=$privateKey, publicKey=$publicKey, presharedKey=$presharedKey, persistentKeepalive=$persistentKeepalive, allowedIps=$allowedIps, blockedAt=$blockedAt, ]';
  }

  WireguardPeer.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    endpoint = json['endpoint'];
    privateKey = json['private_key'];
    publicKey = json['public_key'];
    presharedKey = json['preshared_key'];
    persistentKeepalive = json['persistent_keepalive'];
    allowedIps = (json['allowed_ips'] == null) ?
      null :
      (json['allowed_ips'] as List).cast<String>();
    blockedAt = (json['blocked_at'] == null) ?
      null :
      DateTime.parse(json['blocked_at']);
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (endpoint != null)
      json['endpoint'] = endpoint;
      json['private_key'] = privateKey;
    if (publicKey != null)
      json['public_key'] = publicKey;
      json['preshared_key'] = presharedKey;
      json['persistent_keepalive'] = persistentKeepalive;
    if (allowedIps != null)
      json['allowed_ips'] = allowedIps;
      json['blocked_at'] = blockedAt == null ? null : blockedAt.toUtc().toIso8601String();
    return json;
  }

  static List<WireguardPeer> listFromJson(List<dynamic> json) {
    return json == null ? List<WireguardPeer>() : json.map((value) => WireguardPeer.fromJson(value)).toList();
  }

  static Map<String, WireguardPeer> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, WireguardPeer>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = WireguardPeer.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of WireguardPeer-objects as value to a dart map
  static Map<String, List<WireguardPeer>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<WireguardPeer>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = WireguardPeer.listFromJson(value);
       });
     }
     return map;
  }
}

