part of forestvpn_api.api;

class WireguardProfile {
  
  String id = null;
  
  String deviceId = null;
  
  String deviceName = null;
  
  WireguardInterface interface_ = null;
  
  List<WireguardPeer> peers = [];
  WireguardProfile();

  @override
  String toString() {
    return 'WireguardProfile[id=$id, deviceId=$deviceId, deviceName=$deviceName, interface_=$interface_, peers=$peers, ]';
  }

  WireguardProfile.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    deviceId = json['device_id'];
    deviceName = json['device_name'];
    interface_ = (json['interface'] == null) ?
      null :
      WireguardInterface.fromJson(json['interface']);
    peers = (json['peers'] == null) ?
      null :
      WireguardPeer.listFromJson(json['peers']);
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (deviceId != null)
      json['device_id'] = deviceId;
    if (deviceName != null)
      json['device_name'] = deviceName;
    if (interface_ != null)
      json['interface'] = interface_;
    if (peers != null)
      json['peers'] = peers;
    return json;
  }

  static List<WireguardProfile> listFromJson(List<dynamic> json) {
    return json == null ? List<WireguardProfile>() : json.map((value) => WireguardProfile.fromJson(value)).toList();
  }

  static Map<String, WireguardProfile> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, WireguardProfile>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = WireguardProfile.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of WireguardProfile-objects as value to a dart map
  static Map<String, List<WireguardProfile>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<WireguardProfile>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = WireguardProfile.listFromJson(value);
       });
     }
     return map;
  }
}

